#!/bin/bash

IN_TABLE="out_clust.tab"
DX=8
DY=6
NOISE=200000

N=$(getTabCol.tcl -in $IN_TABLE -var CLUSTID | sort -g | uniq | wc -l)
M=$(wc -l < spec.list)

echo "Number of clusters: $N"
echo "Number of spectra: $M"
echo "Running seriesTab"

seriesTab -in $IN_TABLE -list spec.list \
          -dx $DX -dy $DY -max \
          -xzf $(expr $DX \* 2 + 1) -yzf $(expr $DY \* 2 + 1) \
          -out out_clust_series.tab -verb

rm -f nlinLS.tab nlinLS.log

grep VARS out_clust_series.tab >> nlinLS.tab
grep FORMAT out_clust_series.tab >> nlinLS.tab
echo "" >> nlinLS.tab

for (( i=1; $i<=$N; i++ ))
do
    echo "Fitting cluster #$i."

    rm -f out_clust_"$i"_series.tab
    grep VARS out_clust_series.tab >> out_clust_"$i"_series.tab
    grep FORMAT out_clust_series.tab >> out_clust_"$i"_series.tab
    echo "" >> out_clust_"$i"_series.tab
    awk "\$24 ~ /^$i$/ {print}" out_clust_series.tab >> out_clust_"$i"_series.tab


    
    nlinLS -in out_clust_"$i"_series.tab \
           -out nlinLS_clust_"$i".tab \
           -list spec.list \
           -mod GAUSS1D GAUSS1D SCALE1D -w $DX $DY $increment \
           -noise $NOISE -ppm -norm -iter 1000 -maxf 1000 \
           >> nlinLS.log

    sed '1,14d' nlinLS_clust_"$i".tab >> nlinLS.tab
    
done
